"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var node_hid_1 = __importDefault(require("node-hid"));
var known_headphone_1 = __importDefault(require("../models/known_headphone"));
var gateway_1 = __importDefault(require("../adapters/human_interface_device/gateway"));
var device_1 = __importDefault(require("../adapters/human_interface_device/device"));
var Probe = /** @class */ (function () {
    function Probe() {
        var gateway = new gateway_1.default(node_hid_1.default, device_1.default);
        this.devices = gateway.getUsbDevices();
    }
    Probe.prototype.testUnknownHeadset = function (headsets) {
        return headsets.map(function (device) {
            var knownBytes = [
                [0x0, 0x20],
                [0x06, 0x12],
                [0x06, 0x18],
                [0x40, 0xaa],
                [0x00, 0xb0],
            ];
            var matchedReport, matchedBytes;
            console.log('Testing', device.realDevice().product);
            knownBytes.some(function (byteArray) {
                var report = device.fetchInfo(byteArray);
                if (report.length > 0) {
                    matchedBytes = byteArray;
                    matchedReport = report;
                    console.log('\tSuccess!');
                    return true;
                }
            });
            return {
                device: device,
                matchedBytes: matchedBytes,
                matchedReport: matchedReport,
            };
        });
    };
    Probe.prototype.steelseriesHeadsets = function () {
        return this.devices.filter(function (device) {
            return device.vendorId === known_headphone_1.default.ArctisVendorID;
        });
    };
    return Probe;
}());
exports.default = Probe;
